/*****************************************************************************
* jmenu                                                                      *
* by Matthew L Wilson mlavwilson@hotmail.com, mewilson@bluemoon.net          *
* http://www.bluemoon.net/~mewilson                                          *
* COPYRIGHT NOTICE                                                           *
* Copyright 1999 Matthew L. Wilson  All Rights Reserved.                     *
* Jmenu may be used and modified free of charge by anyone so long            *
* this copyright notice and the comments above remain intact.  By using this *
* code you agree to indemnify Matthew L. Wilson from any liability that      *
* might arise from it's use.                                                 *
*                                                                            *
* Selling the code for this program without prior written consent is         *
* expressly forbidden.  In other words, please ask first before you try and  *
* make money off of my program.                                              *
*                                                                            *
* Obtain permission before redistributing this software over the Internet or *
* in any other medium.  In all cases copyright and header must remain intact.*
******************************************************************************/

// Format of the config  file:
// 1. Line: #|{open|close|}|<iconclosed>|<iconopened>
// Following lines: <node>|{open|close|}|<iconclosed>|<iconopened>|name|location|target|comment
// Format of node: x1.x2.  ...


import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.net.*;
import java.util.StringTokenizer;
import java.io.* ;


public class jmenu
extends Applet
implements MouseListener ,
           MouseMotionListener ,
           AdjustmentListener
{
  Color TEXT_HILIGHT,
        TEXT_NORMAL,
        BACK_GROUND,
        CONNECTORS,
        UNDER_LINE;
  Font  NAME_FONT;
  int   SPACING = 16;
  int   INDENT = 16;

  int Num_Entries=500, Max_Num_Entries=500,
      BufferX,  BufferY, // Used for scrolling up and down.
      MaxLevel, oldItem, // Last entry the mouse was over.
      AppletY,  AppletX; // Size of the applet.

  String   string;       // Used for parameters.

  Graphics b;
  Image    buffer = null;

  Image[]  Icon;         // All the icons

  entry    Item[] = new entry[ Max_Num_Entries ]; //Stores all entries.
  int      I[]    = new int[ Max_Num_Entries ];   //Stores entries visible to the user.

  URL url;               // The URl to open a page.
  MediaTracker tracker;  // Monitors the icons while they are downloaded

  Scrollbar scrollbar ;

  public void init ()
  {
    tracker = new MediaTracker ( this ) ;
    AppletX = getSize().width ;
    AppletY = getSize().height ;

    try
    {
      buffer = createImage ( AppletX , 1000 ) ;
      b = buffer.getGraphics () ;
    }catch ( Exception e )
    {
      getAppletContext().showDocument( getDocumentBase () , "_parent" ) ;
    }

    TEXT_NORMAL  = setParmColor( "0000ff" ) ;
    BACK_GROUND  = setParmColor( getParameter("BACK_GROUND") ) ;
    CONNECTORS   = setParmColor( "c0c0c0" ) ;
    TEXT_HILIGHT = setParmColor( "a52a2a" ) ;
    SPACING      = 26 ;
    INDENT       = 36 ;

    NAME_FONT  = new Font ( "Sans Serif" , Font.PLAIN , 12 ) ;
    b.setFont ( NAME_FONT ) ;



    Icon = new Image[7] ;

    Icon[3] = getImage( getDocumentBase() , "icons/iconBookClosed.gif" ) ;
    tracker.addImage ( Icon[3] , 0 ) ;
    try {tracker.waitForID(0);}
      catch (InterruptedException e) {}
    Icon[4] = getImage( getDocumentBase() , "icons/iconBookOpen.gif" ) ;
    tracker.addImage ( Icon[4] , 0 ) ;
    try {tracker.waitForID(0);}
      catch (InterruptedException e) {}
    Icon[2] = getImage( getDocumentBase() , "icons/iconLeaf.gif" ) ;
    tracker.addImage ( Icon[2] , 0 ) ;
    try {tracker.waitForID(0);}
      catch (InterruptedException e) {}
    Icon[0] = getImage( getDocumentBase() , "icons/iconChapterClosed.gif" ) ;
    tracker.addImage ( Icon[0] , 0 ) ;
    try {tracker.waitForID(0);}
      catch (InterruptedException e) {}
    Icon[1] = getImage( getDocumentBase() , "icons/iconChapterOpen.gif" ) ;
    tracker.addImage ( Icon[1] , 0 ) ;
    try {tracker.waitForID(0);}
      catch (InterruptedException e) {}
    Icon[5] = getImage( getDocumentBase() , "icons/iconSubpage.gif" ) ;
    tracker.addImage ( Icon[5] , 0 ) ;
    try {tracker.waitForID(0);}
      catch (InterruptedException e) {}
    Icon[6] = getImage( getDocumentBase() , "icons/iconLeafSubpage.gif" ) ;
    tracker.addImage ( Icon[6] , 0 ) ;
    try {tracker.waitForID(0);}
      catch (InterruptedException e) {}

 /*   Num_Entries = 0 ;
    while ( true )
    {
      string = getParameter ( "icon" + Num_Entries ) ;
      if ( string == null ) break ;
      Icon[Num_Entries] = getImage( getDocumentBase() , string ) ;
      tracker.addImage ( Icon[Num_Entries] , 0 ) ;
      Num_Entries++ ;
    } */

    Num_Entries = 0 ;
    addFolders ();
    initConnectors () ;

    for ( int i = 1 ; i < Max_Num_Entries ; i++ ) I[i] = -1 ;
    I[0] = 0 ;

    setBackground ( BACK_GROUND ) ;
    BorderLayout bl = new BorderLayout () ;
    setLayout ( bl ) ;

    addMouseMotionListener ( this ) ;
    addMouseListener ( this ) ;

    setFont ( new Font ( "Sans Serif" , Font.PLAIN , 14 ) ) ;
    scrollbar = new Scrollbar () ;
    add("East",scrollbar);
    scrollbar.addAdjustmentListener ( this ) ;

    createTree () ;
    calculateSliderData () ;
  }


  public void addFolders ()
  {
    String parameter , Status , iconclosed , iconopen , Location , Target , Name ;
    BufferedReader fr ;
    int NumOfLines = 0 ;
    String line ;
    char ch ;
    boolean flag ;
    int i ;
    String node , State ;
    int Level ;
    int pointer ;

    String[] lines = new String[Max_Num_Entries] ;

    try {
      URL url = new URL ( getDocumentBase() , "config.txt" ) ;
      fr = new BufferedReader ( new InputStreamReader((url).openStream(), "8859_1") ) ;
      while ( (lines[NumOfLines] = fr.readLine()) != null )
      {
        NumOfLines++ ;
      }
      fr.close () ;
    } catch ( IOException e )
    {
      System.out.println ( "Configuration file could not be read" ) ;
    }

    for ( i = 0 ; i < NumOfLines ; i++ )
    {
      Level = -1 ;
      string = lines[i] ;

      StringTokenizer to = new StringTokenizer ( string , "|" ) ;

      node = to.nextToken () ;
      State = to.nextToken () ;
      iconclosed = to.nextToken () ;
      iconopen = to.nextToken () ;

      if ( to.hasMoreTokens () )
        Name = to.nextToken().trim() ;
      else
        Name = "" ;

      if ( to.hasMoreTokens () )
        Location = to.nextToken().trim() ;
      else
        Location = "" ;

      if ( to.hasMoreTokens () )
         Target = to.nextToken().trim() ;
      else
        Target = "" ;

       if ( to.hasMoreTokens () )
         Status = to.nextToken().trim() ;
       else
         Status = "" ;


      StringTokenizer nodeto = new StringTokenizer ( node , "." , false) ;

      if ( Num_Entries > 0 )
      {
        while ( nodeto.hasMoreTokens () )
        {
          nodeto.nextToken () ;
          Level++ ;
        }
      }

      Item[Num_Entries] = new entry ( "" + Level , iconclosed , iconopen , Location , Target , Name , Status , State ) ;

      Num_Entries++;
    }
  }


  public void initConnectors ()
  {
    int lastConnector ;
    for ( int i = Num_Entries-1 ; i>0 ; i-- )
    {
      try
      {
        lastConnector = Item[i+1].Connector[Item[i].Folder] ;
      }
      catch( Exception e )
      {
        lastConnector = 0 ;
      }

      if ( lastConnector == 0 )
        Item[i].Connector[Item[i].Folder] = 3 ;
      else
        Item[i].Connector[Item[i].Folder] = 2 ;

      for ( int j = i-1 ; j>0 ; j-- )
        if ( Item[i].Folder <= Item[j].Folder ) Item[j].Connector[Item[i].Folder] = 1 ;
      else
        break;
    }
  }


  public void createTree()
  {
    // "I[i]=j" means: In line No. i item No. j is displayed

    int i = 1 , line = 0 , Cur_Folder = 0 ;

    while ( i < Num_Entries )
    {
      if ( Item[0].State.equals ( "closed" ) ) break ;

      line++ ;
      I[line] = i ;

      if ( ( i < Num_Entries-1 ) && ( Item[i].Folder < Item[i+1].Folder ) && ( Item[i].State.equals ( "closed" ) ) )
      {
        Cur_Folder = i++ ;
        while ( Item[i].Folder > Item[Cur_Folder].Folder )
        {
          if ( ++i >= Num_Entries ) break ;
        }
      }
      else i++;
    }

    MaxLevel = line ;
    for ( i = line+1 ; i<= Num_Entries ; i++ )  I[i]= -1 ;

    paintTree();
  }


  public void paintTree()
  {
    b.setColor ( BACK_GROUND ) ;
    b.fillRect ( 0 , 0 , AppletX , AppletY ) ;

    if ( Item[0].State.equals ( "open" ) )
    {
      for ( int i=1 ; I[i] != -1 ; i++ )
      {
        b.setColor(CONNECTORS);
        for ( int j = 0 ; j <= Item[I[i]].Folder ; j++ )
        {
          switch(Item[I[i]].Connector[j])
          {
            case 1: b.drawLine( j*INDENT+((int)INDENT/2)+BufferX, SPACING*i+BufferY,j*INDENT+((int)INDENT/2)+BufferX, SPACING*i+SPACING+BufferY);
                    break;
            case 2: b.drawLine( j*INDENT+((int)INDENT/2)+BufferX, SPACING*i-SPACING/2+BufferY,j*INDENT+((int)INDENT/2)+BufferX, SPACING*i+SPACING+BufferY);
                    b.drawLine( j*INDENT+((int)INDENT/2)+BufferX, SPACING*i+((int)SPACING/2)+BufferY,j*INDENT+INDENT+INDENT/2+BufferX, SPACING*i+((int)SPACING/2)+BufferY);
                    break;
            case 3: b.drawLine( j*INDENT+((int)INDENT/2)+BufferX, SPACING*i-SPACING/2+BufferY,j*INDENT+((int)INDENT/2)+BufferX, SPACING*i+((int)SPACING/2)+BufferY);
                    b.drawLine( j*INDENT+((int)INDENT/2)+BufferX, SPACING*i+((int)SPACING/2)+BufferY,j*INDENT+INDENT+INDENT/2+BufferX, SPACING*i+((int)SPACING/2)+BufferY);
                    break;
          }
        }
      }

      for ( int i=1 ; I[i] != -1 ; i++ )
      {

        if ( Item[I[i]].State.equals ( "open" ) )
        {
          if ( Icon[Item[I[i]].IconOpen] != null )
            b.drawImage( Icon[Item[I[i]].IconOpen] , Item[I[i]].Folder*INDENT+INDENT+BufferX , SPACING*i+BufferY , this ) ;
        }
        else
        {
          if ( Icon[Item[I[i]].IconClosed] != null )
            b.drawImage( Icon[Item[I[i]].IconClosed] , Item[I[i]].Folder*INDENT+INDENT+BufferX , SPACING*i+BufferY , this ) ;
        }

        if ( oldItem == i )
          b.setColor ( TEXT_HILIGHT ) ;
        else
          b.setColor ( TEXT_NORMAL ) ;

		if (Item[I[i]].Name.length() > 21)
          b.drawString( Item[I[i]].Name.substring(0,21)+"...", Item[I[i]].Folder*INDENT+INDENT+INDENT+BufferX, SPACING*i+b.getFontMetrics().getHeight()+BufferY);
        else
          b.drawString( Item[I[i]].Name, Item[I[i]].Folder*INDENT+INDENT+INDENT+BufferX, SPACING*i+b.getFontMetrics().getHeight()+BufferY);
      }
    }

    if ( Item[0].State.equals ( "open" ) )
    {
      if ( Icon[Item[0].IconOpen] != null )
        b.drawImage ( Icon[Item[0].IconOpen] , BufferX , BufferY , null ) ;
    }
    else
    {
      if ( Icon[Item[0].IconClosed] != null )
        b.drawImage ( Icon[Item[0].IconClosed] , BufferX , BufferY , null ) ;
    }

    repaint();
  }

  public void mousePressed ( MouseEvent e ) {} ;
  public void mouseReleased ( MouseEvent e ) {} ;
  public void mouseEntered ( MouseEvent e ) {} ;
  public void mouseExited ( MouseEvent e ) {} ;

  public void mouseClicked ( MouseEvent e )
  {
    int x = e.getX () ;
    int y = e.getY () ;

    y = y - BufferY ;

    if ( y/SPACING > Num_Entries ) return ;

    if ( ( I[y/SPACING] != -1 ) || ( ( y/SPACING ) == 0 ) )
    {
      if ( ( I[y/SPACING] < Num_Entries-1 ) && ( Item[I[y/SPACING]].Folder < Item[I[y/SPACING]+1].Folder ) )
      {
        if( (x/INDENT) == Item[I[y/SPACING]].Folder+1 )
        {
          if ( Item[I[y/SPACING]].State.equals ( "open" ) )
            Item[I[y/SPACING]].State = "closed" ;
          else
            Item[I[y/SPACING]].State = "open" ;
        }
        else
        {
          if ( !Item[I[y/SPACING]].Location.equals ( "" ) )
            showDocument ( Item[I[y/SPACING]].Location , Item[I[y/SPACING]].Target ) ;
          else
            if ( Item[I[y/SPACING]].State.equals ( "open" ) )
              Item[I[y/SPACING]].State = "closed" ;
            else
              Item[I[y/SPACING]].State = "open" ;
        }

        createTree();
      }
      else
        showDocument(Item[I[y/SPACING]].Location, Item[I[y/SPACING]].Target);
    }

    calculateSliderData () ;

  }

  public void mouseDragged ( MouseEvent e ) {} ;

  public void mouseMoved ( MouseEvent e )
  {
    int x = e.getX () ;
    int y = e.getY () ;
    int stringpos, stringpos_alt, maxBreiteString, kommentarLaenge, zeile, stringabst;

    if ( I[(y-BufferY)/SPACING] != -1 )
    {
      if ( (y-BufferY)/SPACING != oldItem )
      {
        if ( oldItem != 0 )
        {
          b.setColor ( BACK_GROUND ) ;
          b.drawLine ( Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX , SPACING*oldItem+SPACING/2+BufferY , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX+(b.getFontMetrics().stringWidth(Item[I[oldItem]].Name)) , SPACING*oldItem+SPACING/2+BufferY ) ;

	  	  maxBreiteString=(AppletX-scrollbar.getSize().width-(Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX+150))/b.getFontMetrics().stringWidth("a");
	  	  stringabst=b.getFontMetrics().getHeight()+2;
	  	  if ((kommentarLaenge=Item[I[oldItem]].Status.length()) > maxBreiteString)
	  	  {
	  	    stringpos=maxBreiteString;
	  	    stringpos_alt=0;
	  	    zeile=0;
	  	    do
	  	    {
	  	      while (Item[I[oldItem]].Status.charAt(stringpos) != ' '){--stringpos; if (stringpos<0) {stringpos=stringpos_alt+maxBreiteString-1; break;}}
	  	      b.drawString ( Item[I[oldItem]].Status.substring(stringpos_alt,stringpos) , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX+150 , SPACING*oldItem+b.getFontMetrics().getHeight()+BufferY+zeile*stringabst ) ;
	  	      ++zeile;
	  	      stringpos_alt=stringpos+1;
	  	      if (maxBreiteString+stringpos > kommentarLaenge)
	  	        stringpos=kommentarLaenge;
	  	      else
	  	        stringpos+=maxBreiteString;
	  	    }
	  	    while (Item[I[oldItem]].Status.substring(stringpos_alt,kommentarLaenge).length() > maxBreiteString);
	  	    b.drawString ( Item[I[oldItem]].Status.substring(stringpos_alt,kommentarLaenge) , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX+150 , SPACING*oldItem+b.getFontMetrics().getHeight()+BufferY+zeile*stringabst ) ;
	  	  }
	  	  else
	  	    b.drawString ( Item[I[oldItem]].Status , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX+150 , SPACING*oldItem+b.getFontMetrics().getHeight()+BufferY ) ;

          b.setColor(TEXT_NORMAL);
          if (Item[I[oldItem]].Name.length() > 21)
            b.drawString ( Item[I[oldItem]].Name.substring(0,21)+"..." , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX , SPACING*oldItem+b.getFontMetrics().getHeight()+BufferY ) ;
          else
            b.drawString ( Item[I[oldItem]].Name , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX , SPACING*oldItem+b.getFontMetrics().getHeight()+BufferY ) ;
        }

        oldItem = (y-BufferY)/SPACING;

        if (oldItem != 0)
        {
          b.setColor ( TEXT_HILIGHT ) ;
          if (Item[I[oldItem]].Name.length() > 21)
            b.drawString( Item[I[oldItem]].Name.substring(0,21)+"..." , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX , SPACING*oldItem+b.getFontMetrics().getHeight()+BufferY ) ;
          else
            b.drawString( Item[I[oldItem]].Name , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX , SPACING*oldItem+b.getFontMetrics().getHeight()+BufferY ) ;
          b.setColor ( Color.black );

	  	  maxBreiteString=(AppletX-scrollbar.getSize().width-(Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX+150))/b.getFontMetrics().stringWidth("a");
	  	  stringabst=b.getFontMetrics().getHeight()+2;
	  	  if ((kommentarLaenge=Item[I[oldItem]].Status.length()) > maxBreiteString)
	  	  {
	  	    stringpos=maxBreiteString;
	  	    stringpos_alt=0;
	  	    zeile=0;
	  	    do
	  	    {
	  	      while (Item[I[oldItem]].Status.charAt(stringpos) != ' '){--stringpos; if (stringpos<0) {stringpos=stringpos_alt+maxBreiteString-1; break;}}
	  	      b.drawString ( Item[I[oldItem]].Status.substring(stringpos_alt,stringpos) , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX+150 , SPACING*oldItem+b.getFontMetrics().getHeight()+BufferY+zeile*stringabst ) ;
	  	      ++zeile;
	  	      stringpos_alt=stringpos+1;
	  	      if (maxBreiteString+stringpos > kommentarLaenge)
	  	        stringpos=kommentarLaenge;
	  	      else
	  	        stringpos+=maxBreiteString;
	  	    }
	  	    while (Item[I[oldItem]].Status.substring(stringpos_alt,kommentarLaenge).length() > maxBreiteString);
	  	    b.drawString ( Item[I[oldItem]].Status.substring(stringpos_alt,kommentarLaenge) , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX+150 , SPACING*oldItem+b.getFontMetrics().getHeight()+BufferY+zeile*stringabst ) ;
	  	  }
	  	  else
	  	    b.drawString ( Item[I[oldItem]].Status , Item[I[oldItem]].Folder*INDENT+INDENT+INDENT+BufferX+150 , SPACING*oldItem+b.getFontMetrics().getHeight()+BufferY ) ;

        }

        repaint () ;


      }
    }

/*
    if ( Item[0].State.equals ( "open" ) )
    {
      if ( ( y > (AppletY-comment.getSize().height - 10 - SPACING ) ) && ( BufferY > - ((SPACING*MaxLevel) - ( AppletY - comment.getSize().height - 10 - SPACING ) ) ) )
      {
        BufferY = BufferY - SPACING ;
        paintTree () ;
        repaint () ;
      }

      if ( (y < 10) && ( BufferY < 0 ) )
      {
        BufferY = BufferY + SPACING ;
        paintTree () ;
        repaint () ;
      }
    }  */
  }

  public void calculateSliderData ()
  {
    int i , treeHeight , visibleHeight , currentPosition ;
    int sliderVisible , sliderLength , sliderPosition ;

    for ( i = 0 ; i < Num_Entries ; i++ )
    {
      if ( I[i] == -1 ) break ;
    }

    treeHeight = i * SPACING ;
    visibleHeight = AppletY - 10 ;
    currentPosition = -BufferY ;

    sliderLength = treeHeight ;
    sliderPosition = currentPosition ;
    sliderVisible = visibleHeight ;

    scrollbar.setValues ( sliderPosition , sliderVisible , 0 , sliderLength ) ;
    scrollbar.setBlockIncrement ( sliderVisible ) ;
    scrollbar.setUnitIncrement ( SPACING ) ;

    if ( sliderVisible < sliderLength )
    {
      scrollbar.setVisible ( true ) ;
    }
    else
    {
      scrollbar.setVisible ( true ) ;
      BufferY = 0 ;
      paintTree () ;

    }

  }

  public void adjustmentValueChanged ( AdjustmentEvent e )
  {
    BufferY = -scrollbar.getValue() ;
    paintTree () ;
    repaint () ;
  }

  public Color setParmColor ( String s ) // Convert hexadecimal RGB parameter to color
  {
    int[] hex = new int[6] ;
    String h ="0123456789abcdef" ;
    Color c = Color.black ;

    if ( ( s != null ) && ( s.length() == 6 ) )
    {
      for ( int i=0 ; i<6 ; i++ )
        for ( int j=0 ; j<16 ; j++ )
          if ( Character.toLowerCase ( s.charAt(i) ) == h.charAt ( j ) ) hex[i] = j ;

      c = new Color ( hex[0]*16+hex[1] , hex[2]*16+hex[3] , hex[4]*16+hex[5] ) ;
    }

    return c;
  }

  public void update ( Graphics g )
  {
    paint ( g ) ;
  }

  public void paint(Graphics g)
  {
    int scrollbarWidth ;

    if(AppletY != getSize().height)
    {
      AppletY = getSize().height;
      createTree();
    }

    if ( ( scrollbar != null ) && scrollbar.isVisible () )
      scrollbarWidth = scrollbar.getSize().width ;
    else
      scrollbarWidth = 0 ;

    g.drawImage(buffer,0,0,null);

  }

  public void showDocument ( String L , String T )
  {
    String Path;
    if ( ( L.startsWith ( "http" ) ) || ( L.startsWith ( "mail" ) ) )
      Path = "" ;
    else
      Path = "" + getCodeBase() ;

    try
    {
      url = new URL ( Path + L ) ;
    }
    catch ( MalformedURLException e )
    {
      showStatus ( "Malformed URL" ) ;
    }

    getAppletContext().showDocument( url, T ) ;
  }
}




